package cn.com.infosec.jce.provider;

import cn.com.infosec.asn1.DERObjectIdentifier;
import cn.com.infosec.asn1.pkcs.PKCSObjectIdentifiers;
import cn.com.infosec.asn1.x509.X509ObjectIdentifiers;
import cn.com.infosec.crypto.params.RSAKeyParameters;
import cn.com.infosec.crypto.params.RSAPrivateCrtKeyParameters;
import java.math.BigInteger;
import java.security.interfaces.RSAPrivateCrtKey;
import java.security.interfaces.RSAPrivateKey;
import java.security.interfaces.RSAPublicKey;

public class RSAUtil {
   public static boolean isRsaOid(DERObjectIdentifier algOid) {
      return algOid.equals(PKCSObjectIdentifiers.rsaEncryption) || algOid.equals(X509ObjectIdentifiers.id_ea_rsa) || algOid.equals(PKCSObjectIdentifiers.id_RSASSA_PSS) || algOid.equals(PKCSObjectIdentifiers.id_RSAES_OAEP);
   }

   public static RSAKeyParameters generatePublicKeyParameter(RSAPublicKey key) {
      RSAPublicKey var10002 = key;
      BigInteger key1 = key.getModulus();
      BigInteger var1 = var10002.getPublicExponent();
      return new RSAKeyParameters(false, key1, var1);
   }

   public static RSAKeyParameters generatePrivateKeyParameter(RSAPrivateKey key) {
      BigInteger var1;
      BigInteger key1;
      if (key instanceof RSAPrivateCrtKey) {
         RSAPrivateCrtKey key2 = (RSAPrivateCrtKey)key;
         RSAPrivateCrtKey var10 = key2;
         RSAPrivateCrtKey var10003 = key2;
         RSAPrivateCrtKey var10004 = key2;
         RSAPrivateCrtKey var10005 = key2;
         RSAPrivateCrtKey var10006 = key2;
         RSAPrivateCrtKey var10007 = key2;
         RSAPrivateCrtKey var10008 = key2;
         key1 = key2.getModulus();
         var1 = var10008.getPublicExponent();
         BigInteger var2 = var10007.getPrivateExponent();
         BigInteger var3 = var10006.getPrimeP();
         BigInteger var4 = var10005.getPrimeQ();
         BigInteger var5 = var10004.getPrimeExponentP();
         BigInteger var6 = var10003.getPrimeExponentQ();
         BigInteger var7 = var10.getCrtCoefficient();
         return new RSAPrivateCrtKeyParameters(key1, var1, var2, var3, var4, var5, var6, var7);
      } else {
         RSAPrivateKey var10002 = key;
         key1 = key.getModulus();
         var1 = var10002.getPrivateExponent();
         return new RSAKeyParameters(true, key1, var1);
      }
   }
}
